#ifndef __KEY_LEARNER_H
#define __KEY_LEARNER_H

#include <vdr/menuitems.h>
#include <vdr/thread.h>

class cMenuEditKey : public cMenuEditItem {
public:
   cMenuEditKey(const char* name, cRemote *_remote, cKey *_key, bool New=false);
   virtual ~cMenuEditKey();
   eOSState ProcessKey(eKeys Key);
   cKey *Key() { return key; }
   cRemote *Remote() { return remote; }

   void StartLearning(void);
protected:
   void* value;
   void Set(void);
   void LearnOneKey(void);
   void FinishLearning(void);
   void SetLearnResult(char * newCode);

   void Action(void);
protected:
   cRemote *remote;
   cKey *key;
   enum {
     LEARN_OFF,
     LEARN_GET_KEY,
     LEARN_TIMEOUT,
     LEARN_ABORTED,
     LEARN_DONE
   } learning_state;
};
#endif
