
#include <vdr/remote.h>
#include "menu_remote_list.h"
#include "menu_remote_view.h"

class cRemoteListItem : public cOsdItem {
public:
   cRemote *remote;
   cRemoteListItem(cRemote *_remote);
   virtual ~cRemoteListItem();
   void Set(void);
};

cRemoteListItem::cRemoteListItem(cRemote *_remote)
{
   remote = _remote;
   Set();
}

cRemoteListItem::~cRemoteListItem()
{
}

void cRemoteListItem::Set(void)
{
   char *buffer = 0;
   asprintf(&buffer, "%s", remote->Name());
   SetText(buffer);
   free(buffer);
}

// --- cRemoteListMenu -----------------------------------------------------

cRemoteListMenu::cRemoteListMenu(void)
:cOsdMenu("")
{
   cRemote *remote;
   char *buffer = NULL;

   remote=Remotes.First();
   while (remote) {
      Add(new cRemoteListItem(remote));
      remote = Remotes.Next(remote);
   }

   //Add(last_key_item = new cRemoteListItem(0));

   asprintf(&buffer, tr("Remote Controls (%d found)"), Remotes.Count());
   SetTitle(buffer);
   free(buffer);

   //SetHelp(tr("Button$Edit"), tr("Button$New"), tr("Button$Delete"), tr("Button$Actions"));
   SetHelp("", "Loading old Keys");
   
}

cRemoteListMenu::~cRemoteListMenu()
{
}

void cRemoteListMenu::ForceLearning(void)
{
   Add(new cOsdItem("FORCED"));
}

eOSState cRemoteListMenu::Actions(eKeys Key)
{
   if (HasSubMenu() || Count() == 0)
      return osContinue;
   //cRemote* search = CurrentRemote();
   return osContinue;
}

cRemote* cRemoteListMenu::CurrentRemote(void)
{
   cRemoteListItem *item = dynamic_cast<cRemoteListItem*>( Get(Current()) );
   if (item)
      return item->remote;

   return NULL;
}

void cRemoteListMenu::SetLastKey(eKeys Key)
{
   last_key_item->SetText(cKey::ToString(Key));
}

eOSState cRemoteListMenu::ProcessKey(eKeys Key)
{
   //SetLastKey(Key);
   eOSState state = cOsdMenu::ProcessKey(Key);
   if (state == osUnknown) {
      cRemote *remote = CurrentRemote();
      switch (Key) {
         case kOk:
	    if (remote)
	       state = AddSubMenu(new cRemoteViewMenu(CurrentRemote()));
	    break;
	    // state = Actions(kOk); break;
         case kGreen:
	    SetStatus("Loading saved keys");
	    //calling this dies vdr up to now
	    //Keys.Load();
	    break;
	 default: break;
      }
   }
   return state;
}

